stages:
  - build
  - deploy

bootstrap:
  stage: build
  image: $CC_CLI_IMAGE:$CC_CLI_VERSION
  script:
    - cc cd generate-gitlab-ci --out cloud-control-cd.gitlab-ci.yml
  rules:
    - if: $CI_PIPELINE_SOURCE == "pipeline"
      when: never
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
  artifacts:
    paths:
      - cloud-control-cd.gitlab-ci.yml

deploy:
  stage: deploy
  trigger:
    include:
      - artifact: cloud-control-cd.gitlab-ci.yml
        job: bootstrap
    strategy: depend
  rules:
    - if: $CI_PIPELINE_SOURCE == "pipeline"
      when: never
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
  needs:
    - bootstrap

update artifacts:
  stage: build
  image: $CC_CLI_IMAGE:$CC_CLI_VERSION
  services:
    - docker:dind
  before_script:
    - apk update && apk add openssh git
    - eval $(ssh-agent -s)
    - echo "${SSH_PUSH_KEY}" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - git config --global user.email "$GITLAB_USER_EMAIL"
    - git config --global user.name "$GITLAB_USER_NAME"
    - ssh-keyscan "$CI_SERVER_SHELL_SSH_HOST" >> ~/.ssh/known_hosts
    - chmod 644 ~/.ssh/known_hosts
  script:
    - cc ci update-artifacts
    - git add .
    - git commit -m "Updated artifacts" --allow-empty
    - git remote rm origin && git remote add origin ssh://git@$CI_SERVER_SHELL_SSH_HOST:$CI_SERVER_SHELL_SSH_PORT/$CI_PROJECT_PATH.git
    - git push origin HEAD:$CI_COMMIT_REF_NAME
  rules:
    - if: $CI_PIPELINE_SOURCE == "pipeline" && $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
